// 
// Decompiled by Procyon v0.5.36
// 

package com.justinmind.generatejquerymobile.handlers;

import java.io.Reader;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.LinkedList;
import java.io.DataInputStream;
import java.util.UUID;
import java.util.regex.Pattern;
import java.util.Enumeration;
import java.io.BufferedInputStream;
import java.util.zip.ZipFile;
import java.io.BufferedOutputStream;
import java.io.InputStream;
import java.util.zip.ZipInputStream;
import java.util.Vector;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.nio.ByteBuffer;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
import java.io.OutputStream;
import java.util.zip.GZIPOutputStream;
import java.util.zip.ZipException;
import java.util.Collections;
import java.util.Arrays;
import java.nio.channels.FileChannel;
import java.nio.channels.FileLock;
import java.nio.channels.WritableByteChannel;
import java.io.FileInputStream;
import java.util.Iterator;
import java.util.Collection;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class FileUtils
{
    private static final int BUFFER_SIZE = 16384;
    private static String tempDir;
    public static final List<String> GENERATION_FILES;
    public static final List<String> OLD_FILES;
    
    static {
        (GENERATION_FILES = new ArrayList<String>()).add("resources");
        FileUtils.GENERATION_FILES.add("review");
        FileUtils.GENERATION_FILES.add("test");
        FileUtils.GENERATION_FILES.add("annotations.json");
        FileUtils.GENERATION_FILES.add("index.html");
        (OLD_FILES = new ArrayList<String>()).add("scenarios.xml");
        FileUtils.OLD_FILES.add("variables.xml");
        FileUtils.OLD_FILES.add("events");
    }
    
    public static boolean deepDeleteDir(final String completName) {
        boolean allDeleted = true;
        final File dir = new File(completName);
        if (dir.exists()) {
            final String[] content = dir.list();
            for (int i = 0; i < content.length; ++i) {
                final File file = new File(String.valueOf(completName) + "/" + content[i]);
                if (file.isDirectory()) {
                    deepDeleteDir(String.valueOf(completName) + "/" + content[i]);
                }
                else {
                    file.delete();
                }
            }
            allDeleted = dir.delete();
        }
        return allDeleted;
    }
    
    public static void deepDeleteDirExceptRoot(final String completeName) {
        final File dir = new File(completeName);
        if (dir.exists()) {
            final String[] content = dir.list();
            for (int i = 0; i < content.length; ++i) {
                final File file = new File(String.valueOf(completeName) + File.separator + content[i]);
                if (file.isDirectory()) {
                    deepDeleteDir(String.valueOf(completeName) + File.separator + content[i]);
                }
                else {
                    file.delete();
                }
            }
        }
    }
    
    public static void deepDelete(final String path) {
        final File f = new File(path);
        if (f.exists()) {
            if (f.isDirectory()) {
                deepDeleteDir(f.getAbsolutePath());
            }
            else {
                f.delete();
            }
        }
    }
    
    public static File deepCreateFile(final File f) throws IOException {
        safeMkdirs(f.getParentFile());
        f.createNewFile();
        return f;
    }
    
    public static void safeMkdirs(final File dir) {
        int counter = 0;
        while (!dir.mkdirs()) {
            Thread.yield();
            if (dir.exists()) {
                break;
            }
            if (++counter == 5) {
                System.out.println("Couldn't create dir: " + dir.getAbsolutePath());
                break;
            }
        }
    }
    
    private static FileOutputStream getSafeFileOutputStream(final File dest, final Boolean append) throws FileNotFoundException {
        int counter = 0;
        FileOutputStream fos = null;
        while (counter < 5) {
            try {
                fos = new FileOutputStream(dest, append);
                break;
            }
            catch (FileNotFoundException fnfe) {
                Thread.yield();
                if (++counter == 5) {
                    System.out.println("Couldn't get file: " + dest.getAbsolutePath());
                    throw fnfe;
                }
                continue;
            }
        }
        return fos;
    }
    
    public static void copyToDirectory(final Collection<?> sources, final String dest) throws IOException {
        for (final Object source : sources) {
            copyToDirectory(source, dest);
        }
    }
    
    public static void copyToDirectory(final Object source, final String destPath) throws IOException {
        File srcFile = null;
        if (source instanceof String) {
            srcFile = new File((String)source);
        }
        else if (source instanceof File) {
            srcFile = (File)source;
        }
        if (srcFile != null && srcFile.exists()) {
            if (srcFile.isDirectory()) {
                final String sourcePath = srcFile.getPath();
                String[] list;
                for (int length = (list = srcFile.list()).length, i = 0; i < length; ++i) {
                    final String child = list[i];
                    copyToDirectory(String.valueOf(sourcePath) + File.separator + child, String.valueOf(destPath) + File.separator + srcFile.getName());
                }
            }
            else {
                copyFileTo(srcFile.getPath(), String.valueOf(destPath) + File.separator + srcFile.getName(), false, true);
            }
        }
    }
    
    public static void copyFileTo(final String sourceFilePath, final String destinationFilePath) throws IOException {
        copyFileTo(sourceFilePath, destinationFilePath, false, true);
    }
    
    public static void copyFileTo(final File source, final String destinationPath) throws IOException {
        copyFileTo(source, new File(destinationPath), false, true);
    }
    
    public static void copyFileTo(final String sourceFilePath, final String destinationFilePath, final Boolean append, final Boolean overwrite) throws IOException {
        final File src = new File(sourceFilePath);
        final File dest = new File(destinationFilePath);
        copyFileTo(src, dest, append, overwrite);
    }
    
    public static void copyFilesTo(final Collection<String> srcFiles, final String destDir) throws IOException {
        for (final String src : srcFiles) {
            final File origin = new File(src);
            copyFileTo(origin, new File(String.valueOf(destDir) + File.separator + origin.getName()), false, true);
        }
    }
    
    public static void copyFilesTo(final List<File> srcFiles, final File dest, final Boolean append, final Boolean overwrite) throws IOException {
        for (final File src : srcFiles) {
            copyFileTo(src, dest, append, overwrite);
        }
    }
    
    public static void copyFileTo(final File src, final File dest) throws IOException {
        copyFileTo(src, dest, false, true);
    }
    
    public static void copyFileTo(final File src, File dest, final Boolean append, final Boolean overwrite) throws IOException {
        if (src.exists() && !src.getAbsolutePath().equals(dest.getAbsolutePath())) {
            if (!dest.exists()) {
                safeMkdirs(dest.getParentFile());
                dest.createNewFile();
            }
            else if (dest.isDirectory()) {
                dest = new File(String.valueOf(dest.getPath()) + File.separator + src.getName());
                dest.createNewFile();
            }
            else if (dest.exists() && !overwrite) {
                return;
            }
            final FileLock lock = null;
            FileChannel in = null;
            FileChannel out = null;
            try {
                in = new FileInputStream(src).getChannel();
                out = getSafeFileOutputStream(dest, append).getChannel();
                in.transferTo(0L, in.size(), out);
            }
            finally {
                if (in != null) {
                    in.close();
                }
                if (lock != null && lock.isValid()) {
                    lock.release();
                }
                if (out != null) {
                    out.close();
                }
            }
            if (in != null) {
                in.close();
            }
            if (lock != null && lock.isValid()) {
                lock.release();
            }
            if (out != null) {
                out.close();
            }
        }
    }
    
    public static void copyDirectoryIntoDirectory(final String sourcePath, final String destinationPath) throws IOException {
        final File source = new File(sourcePath);
        if (source.isDirectory()) {
            final String[] files = source.list();
            for (int i = 0; i < files.length; ++i) {
                copyDirectoryIntoDirectory(String.valueOf(sourcePath) + File.separator + files[i], String.valueOf(destinationPath) + File.separator + files[i]);
            }
        }
        else {
            copyFileTo(source, destinationPath);
        }
    }
    
    public static void copyDirectoryTo(final String sourcePath, final String destinationPath) throws IOException {
        copyDirectoryTo(sourcePath, destinationPath, new ArrayList<String>(), false, true);
    }
    
    public static void copyDirectoryTo(final String sourcePath, final String destinationPath, final Boolean append, final Boolean overwrite) throws IOException {
        copyDirectoryTo(sourcePath, destinationPath, new ArrayList<String>(), append, overwrite);
    }
    
    public static void copyDirectoryTo(final String sourcePath, final String destinationPath, final Collection<String> excludedFiles, final Boolean append, final Boolean overwrite) throws IOException {
        final File src = new File(sourcePath);
        final File dest = new File(destinationPath);
        if (src.exists() && !src.getAbsolutePath().equals(dest.getAbsolutePath()) && isNotExcluded(sourcePath) && !excludedFiles.contains(src.getName())) {
            if (!dest.exists()) {
                if (dest.isDirectory()) {
                    safeMkdirs(dest);
                }
                else {
                    final String correctedDestinationPath = replaceFileSeparator(destinationPath);
                    safeMkdirs(new File(correctedDestinationPath.substring(0, correctedDestinationPath.lastIndexOf("/"))));
                }
            }
            if (src.isDirectory()) {
                final String[] files = src.list();
                if (files == null) {
                    throw new IOException("Error listing the files on the directory: " + src);
                }
                String[] array;
                for (int length = (array = files).length, i = 0; i < length; ++i) {
                    final String file = array[i];
                    copyDirectoryTo(String.valueOf(sourcePath) + File.separator + file, String.valueOf(destinationPath) + File.separator + file, excludedFiles, append, overwrite);
                }
            }
            else {
                copyFileTo(src, dest, append, overwrite);
            }
        }
    }
    
    public static List<File> listFilesUnder(final File src, final boolean addDirectory) throws FileNotFoundException {
        return listFilesUnder(src, addDirectory, Arrays.asList(""));
    }
    
    public static List<File> listFilesUnder(final File src, final boolean addDirectory, final String fileExtension) throws FileNotFoundException {
        validateDirectory(src);
        final List<File> result = getFilesUnderNoSort(src, addDirectory, Arrays.asList(fileExtension), null, null);
        Collections.sort(result);
        return result;
    }
    
    public static List<File> listFilesUnder(final File src, final boolean addDirectory, final List<String> fileExtensions) throws FileNotFoundException {
        validateDirectory(src);
        final List<File> result = getFilesUnderNoSort(src, addDirectory, fileExtensions, null, null);
        Collections.sort(result);
        return result;
    }
    
    public static List<File> listFilesUnderNotExcluded(final File src, final boolean addDirectory, final List<String> includeExtensions, final List<String> excludeExtensions, final List<String> excludeFolders) throws FileNotFoundException {
        validateDirectory(src);
        final List<File> result = getFilesUnderNoSort(src, addDirectory, includeExtensions, excludeExtensions, excludeFolders);
        Collections.sort(result);
        return result;
    }
    
    private static List<File> getFilesUnderNoSort(final File src, final boolean addDirectory, final List<String> includeExtensions, final List<String> excludeExtensions, final List<String> excludeFolders) throws FileNotFoundException {
        final List<File> result = new ArrayList<File>();
        final Boolean hasIncludeFilter = includeExtensions != null && !includeExtensions.isEmpty();
        final Boolean hasExcludeFilter = excludeExtensions != null && !excludeExtensions.isEmpty();
        File[] listFiles;
        for (int length = (listFiles = src.listFiles()).length, i = 0; i < length; ++i) {
            final File file = listFiles[i];
            if (file.isFile()) {
                Boolean includeFile = true;
                if (hasIncludeFilter) {
                    for (final String fileExtension : includeExtensions) {
                        if (file.getName().endsWith(fileExtension)) {
                            includeFile = true;
                            break;
                        }
                        includeFile = false;
                    }
                }
                if (hasExcludeFilter) {
                    for (final String fileExtension : excludeExtensions) {
                        if (file.getName().endsWith(fileExtension)) {
                            includeFile = false;
                            break;
                        }
                    }
                }
                if (includeFile) {
                    result.add(file);
                }
            }
            else {
                Boolean includeFolder = true;
                if (excludeFolders != null && !excludeFolders.isEmpty()) {
                    for (final String folderName : excludeFolders) {
                        if (file.getName().equals(folderName)) {
                            includeFolder = false;
                            break;
                        }
                    }
                }
                if (includeFolder) {
                    if (addDirectory && !hasIncludeFilter && !hasExcludeFilter) {
                        result.add(file);
                    }
                    final List<File> deeperList = getFilesUnderNoSort(file, addDirectory, includeExtensions, excludeExtensions, excludeFolders);
                    result.addAll(deeperList);
                }
            }
        }
        return result;
    }
    
    private static void validateDirectory(final File aDirectory) throws FileNotFoundException {
        if (aDirectory == null) {
            throw new IllegalArgumentException("Directory should not be null.");
        }
        if (!aDirectory.exists()) {
            throw new FileNotFoundException("Directory does not exist: " + aDirectory);
        }
        if (!aDirectory.isDirectory()) {
            throw new IllegalArgumentException("Is not a directory: " + aDirectory);
        }
        if (!aDirectory.canRead()) {
            throw new IllegalArgumentException("Directory cannot be read: " + aDirectory);
        }
    }
    
    public static boolean isFileInDirectory(final File folder, final String fileName) {
        boolean found = false;
        try {
            validateDirectory(folder);
            final String[] files = folder.list();
            for (int i = 0; i < files.length; ++i) {
                if (files[i].equals(fileName)) {
                    found = true;
                    break;
                }
            }
        }
        catch (FileNotFoundException e) {
            throw new IllegalArgumentException("Directory does not exist: " + folder);
        }
        return found;
    }
    
    public static void gzip(final File file) throws ZipException, IOException {
        gzip(file, file.getAbsolutePath(), false);
    }
    
    public static void gzip(final List<File> files, final Boolean replace) throws ZipException, IOException {
        for (final File file : files) {
            gzip(file, file.getAbsolutePath(), replace);
        }
    }
    
    public static void gzip(final File file, String dest, final Boolean replace) throws ZipException, IOException {
        if (file.exists()) {
            FileInputStream in = null;
            GZIPOutputStream out = null;
            try {
                in = new FileInputStream(file);
                if (!dest.endsWith(".gz")) {
                    dest = String.valueOf(dest) + ".gz";
                }
                File output = new File(dest);
                if (output.exists()) {
                    dest = String.valueOf(dest) + ".gz";
                }
                output = deepCreateFile(new File(dest));
                out = new GZIPOutputStream(new FileOutputStream(output));
                final byte[] buf = new byte[1024];
                int len;
                while ((len = in.read(buf)) > 0) {
                    out.write(buf, 0, len);
                }
                in.close();
                in = null;
                out.finish();
                out.close();
                out = null;
                if (replace) {
                    deepDelete(file.getAbsolutePath());
                    output.renameTo(new File(output.getAbsolutePath().substring(0, dest.length() - 3)));
                }
            }
            catch (IOException e) {
                throw new ZipException(e.getMessage());
            }
            finally {
                if (in != null) {
                    try {
                        in.close();
                    }
                    catch (IOException e2) {
                        throw e2;
                    }
                }
                if (out != null) {
                    try {
                        out.close();
                    }
                    catch (IOException e2) {
                        throw e2;
                    }
                }
            }
            if (in != null) {
                try {
                    in.close();
                }
                catch (IOException e2) {
                    throw e2;
                }
            }
            if (out != null) {
                try {
                    out.close();
                }
                catch (IOException e2) {
                    throw e2;
                }
            }
        }
    }
    
    public static void zip(final List<String> filesToZip, final String destinationPath, final String zipFileName) throws IOException {
        zip(filesToZip, destinationPath, zipFileName, "");
    }
    
    public static void zip(final List<String> filesToZip, final String destinationPath, final String zipFileName, final String entryPrefix) throws IOException {
        ZipOutputStream out = null;
        FileInputStream fis = null;
        FileOutputStream fos = null;
        try {
            fos = new FileOutputStream(String.valueOf(destinationPath) + File.separator + zipFileName);
            out = new ZipOutputStream(fos);
            out.setLevel(-1);
            final byte[] readBuffer = new byte[16384];
            int bytesIn = 0;
            for (final String dirPath : filesToZip) {
                final File f = new File(dirPath);
                final String prefixToRemove = getPrefixToRemove(f.getPath());
                if (f.isDirectory()) {
                    zipDir(dirPath, out, prefixToRemove);
                }
                else {
                    fis = new FileInputStream(f);
                    final String entryPath = removePrefix(f.getPath(), prefixToRemove);
                    final ZipEntry anEntry = new ZipEntry(String.valueOf(entryPrefix) + entryPath);
                    out.putNextEntry(anEntry);
                    while ((bytesIn = fis.read(readBuffer)) != -1) {
                        out.write(readBuffer, 0, bytesIn);
                    }
                    out.flush();
                    out.closeEntry();
                    fis.close();
                }
            }
            out.close();
            fos.close();
        }
        catch (IOException e) {
            throw e;
        }
        finally {
            if (out != null) {
                out.close();
            }
            if (fis != null) {
                fis.close();
            }
            if (fos != null) {
                fos.close();
            }
        }
        if (out != null) {
            out.close();
        }
        if (fis != null) {
            fis.close();
        }
        if (fos != null) {
            fos.close();
        }
    }
    
    public static File makeZipFile(final String tempFolder, final String name, final String zipRootFolder) throws IOException {
        try {
            final File zipfile = new File(String.valueOf(tempFolder) + name);
            zipfile.delete();
            zipfile.createNewFile();
            final List<String> files = new ArrayList<String>();
            final File dir = new File(String.valueOf(tempFolder) + zipRootFolder);
            files.add(dir.getPath());
            zip(files, tempFolder, zipfile.getName());
            return zipfile;
        }
        catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }
    
    public static void zipExport(final List<String> filesToZip, final String destinationPath, final String zipFileName, final String prefixToRemove) throws IOException {
        ZipOutputStream out = null;
        FileInputStream fis = null;
        FileOutputStream fos = null;
        try {
            fos = new FileOutputStream(String.valueOf(destinationPath) + File.separator + zipFileName);
            out = new ZipOutputStream(fos);
            out.setLevel(-1);
            final byte[] readBuffer = new byte[16384];
            int bytesIn = 0;
            for (final String dirPath : filesToZip) {
                final File f = new File(dirPath);
                if (f.isDirectory()) {
                    zipDir(dirPath, out, prefixToRemove);
                }
                else {
                    fis = new FileInputStream(f);
                    final String entryPath = removePrefix(f.getPath(), prefixToRemove);
                    final ZipEntry anEntry = new ZipEntry(entryPath);
                    out.putNextEntry(anEntry);
                    while ((bytesIn = fis.read(readBuffer)) != -1) {
                        out.write(readBuffer, 0, bytesIn);
                    }
                    out.flush();
                    out.closeEntry();
                    fis.close();
                }
            }
            out.close();
            fos.close();
        }
        catch (IOException e) {
            throw e;
        }
        finally {
            if (out != null) {
                out.close();
            }
            if (fos != null) {
                fos.close();
            }
            if (fis != null) {
                fis.close();
            }
        }
        if (out != null) {
            out.close();
        }
        if (fos != null) {
            fos.close();
        }
        if (fis != null) {
            fis.close();
        }
    }
    
    public static File zipProject(final String src, final String dest, final Collection<String> excludes) throws IOException {
        return zipProject(src, dest, excludes, "");
    }
    
    public static File zipProject(final String src, final String dest, final Collection<String> excludes, final String entriesPrefix) throws IOException {
        File output = null;
        final File project = new File(src);
        if (!project.isDirectory()) {
            throw new IllegalArgumentException("project path is not a directory");
        }
        if (project.canRead()) {
            ZipOutputStream out = null;
            try {
                out = new ZipOutputStream(new FileOutputStream(dest));
                final ByteBuffer buffer = ByteBuffer.allocate(16384);
                zipDirProject(src, out, buffer, entriesPrefix, excludes);
                output = new File(dest);
            }
            finally {
                if (out != null) {
                    out.close();
                }
            }
            if (out != null) {
                out.close();
            }
            return output;
        }
        throw new IllegalArgumentException("project path cannot be read");
    }
    
    private static void zipDirProject(final String src, final ZipOutputStream out, final ByteBuffer buffer, final String entryPrefix, final Collection<String> excludes) throws IOException {
        final File zipSource = new File(src);
        String[] list;
        for (int length2 = (list = zipSource.list()).length, i = 0; i < length2; ++i) {
            final String name = list[i];
            if (!excludes.contains(name)) {
                final File file = new File(zipSource, name);
                if (file.isDirectory()) {
                    final String dirEntryName = String.valueOf(entryPrefix) + name + "/";
                    out.putNextEntry(new ZipEntry(dirEntryName));
                    zipDirProject(file.getPath(), out, buffer, dirEntryName, new ArrayList<String>() {});
                }
                else {
                    out.putNextEntry(new ZipEntry(String.valueOf(entryPrefix) + name));
                    FileChannel in = null;
                    try {
                        in = new FileInputStream(file).getChannel();
                        int length;
                        while ((length = in.read(buffer)) != -1) {
                            buffer.flip();
                            out.write(buffer.array(), 0, length);
                            buffer.clear();
                        }
                    }
                    finally {
                        if (in != null) {
                            in.close();
                        }
                    }
                    if (in != null) {
                        in.close();
                    }
                }
                out.closeEntry();
            }
        }
    }
    
    public static byte[] ZipFromDiskToMemory(final List<String> filesToZip) throws IOException {
        final ByteArrayOutputStream result = new ByteArrayOutputStream();
        final ZipOutputStream out = new ZipOutputStream(result);
        out.setLevel(-1);
        for (final String dirPath : filesToZip) {
            final File file = new File(dirPath);
            final String prefixToRemove = getPrefixToRemove(file.getPath());
            zipDir(dirPath, out, prefixToRemove);
        }
        result.close();
        out.close();
        return result.toByteArray();
    }
    
    private static String getPrefixToRemove(final String dirPath) {
        final int i = dirPath.lastIndexOf(File.separator);
        return dirPath.substring(0, i + 1);
    }
    
    public static byte[] ZipFromMemoryToMemory(final List<Object[]> filesToZip) throws IOException {
        int bytesIn = 0;
        final byte[] readBuffer = new byte[16384];
        final ByteArrayOutputStream result = new ByteArrayOutputStream();
        final ZipOutputStream out = new ZipOutputStream(result);
        for (final Object[] element : filesToZip) {
            out.putNextEntry((ZipEntry)element[0]);
            final ByteArrayInputStream bis = new ByteArrayInputStream((byte[])element[1]);
            while ((bytesIn = bis.read(readBuffer)) != -1) {
                out.write(readBuffer, 0, bytesIn);
            }
            bis.close();
        }
        out.close();
        result.close();
        return result.toByteArray();
    }
    
    private static void zipDir(final String dir2zip, final ZipOutputStream zos, final String prefixToRemove) throws IOException {
        final File zipDirFile = new File(dir2zip);
        final String[] dirList = zipDirFile.list();
        final byte[] readBuffer = new byte[16384];
        int bytesIn = 0;
        for (int i = 0; i < dirList.length; ++i) {
            final File f = new File(zipDirFile, dirList[i]);
            if (f.isDirectory()) {
                final String filePath = f.getPath();
                zipDir(filePath, zos, prefixToRemove);
            }
            else {
                final FileInputStream fis = new FileInputStream(f);
                final String entryPath = removePrefix(f.getPath(), prefixToRemove);
                final ZipEntry anEntry = new ZipEntry(entryPath);
                zos.putNextEntry(anEntry);
                while ((bytesIn = fis.read(readBuffer)) != -1) {
                    zos.write(readBuffer, 0, bytesIn);
                }
                zos.flush();
                zos.closeEntry();
                fis.close();
            }
        }
        if (dirList.length == 0) {
            final String entryPath2 = removePrefix(zipDirFile.getPath(), prefixToRemove);
            final ZipEntry anEntry2 = new ZipEntry(String.valueOf(entryPath2) + "/");
            zos.putNextEntry(anEntry2);
            zos.closeEntry();
        }
    }
    
    private static String removePrefix(final String path, final String prefix) {
        return path.substring(prefix.length(), path.length());
    }
    
    public static List<Object[]> UnZipFromMemoryToMemory(final byte[] zipedData) throws Exception {
        final List<Object[]> result = new Vector<Object[]>();
        ByteArrayOutputStream bos = null;
        final byte[] data = new byte[16384];
        final ZipInputStream zis = new ZipInputStream(new ByteArrayInputStream(zipedData));
        ZipEntry entry;
        while ((entry = zis.getNextEntry()) != null) {
            bos = new ByteArrayOutputStream();
            int count;
            while ((count = zis.read(data, 0, 16384)) != -1) {
                bos.write(data, 0, count);
            }
            final Object[] tupla = { entry, bos.toByteArray() };
            result.add(tupla);
        }
        zis.close();
        if (bos != null) {
            bos.close();
        }
        return result;
    }
    
    public static void UnZipFromMemoryToDisk(final byte[] zipedFile, final String destinationFolder) throws IOException {
        BufferedOutputStream dest = null;
        final byte[] data = new byte[16384];
        final ZipInputStream zis = new ZipInputStream(new ByteArrayInputStream(zipedFile));
        ZipEntry entry;
        while ((entry = zis.getNextEntry()) != null) {
            final File entryFile = new File(String.valueOf(destinationFolder) + File.separator + entry.getName());
            if (entryFile.isDirectory()) {
                safeMkdirs(entryFile);
            }
            else {
                final File parent = entryFile.getParentFile();
                safeMkdirs(parent);
                final FileOutputStream fos = new FileOutputStream(entryFile);
                dest = new BufferedOutputStream(fos, 16384);
                int count;
                while ((count = zis.read(data, 0, 16384)) != -1) {
                    dest.write(data, 0, count);
                }
                dest.flush();
                dest.close();
            }
        }
        zis.close();
    }
    
    public static void unZip(final String zipFilePath, final String destinationFolder, final String prefixToRemove) throws IOException {
        BufferedOutputStream dest = null;
        FileOutputStream fos = null;
        BufferedInputStream is = null;
        final File zipFilefile = new File(zipFilePath);
        final int prefixLength = prefixToRemove.length();
        final ZipFile zipfile = new ZipFile(zipFilefile, 1);
        final Enumeration<? extends ZipEntry> e = zipfile.entries();
        try {
            while (e.hasMoreElements()) {
                final ZipEntry entry = (ZipEntry)e.nextElement();
                is = new BufferedInputStream(zipfile.getInputStream(entry));
                final byte[] data = new byte[16384];
                String entryPath = String.valueOf(destinationFolder) + File.separator;
                if (prefixLength > 0 && entry.getName().startsWith(prefixToRemove)) {
                    entryPath = String.valueOf(entryPath) + entry.getName().substring(prefixLength);
                }
                else {
                    entryPath = String.valueOf(entryPath) + entry.getName();
                }
                entryPath = entryPath.replace("\\", File.separator);
                final File entryFile = new File(entryPath);
                if (entry.isDirectory()) {
                    safeMkdirs(entryFile);
                }
                else {
                    final File parent = entryFile.getParentFile();
                    safeMkdirs(parent);
                    try {
                        fos = new FileOutputStream(entryFile);
                    }
                    catch (FileNotFoundException ex) {
                        continue;
                    }
                    dest = new BufferedOutputStream(fos, 16384);
                    int count;
                    while ((count = is.read(data, 0, 16384)) != -1) {
                        dest.write(data, 0, count);
                    }
                    dest.flush();
                }
                is.close();
                if (dest != null) {
                    dest.close();
                }
                if (fos != null) {
                    fos.close();
                }
            }
        }
        catch (IOException e2) {
            throw e2;
        }
        finally {
            zipfile.close();
            is.close();
            if (dest != null) {
                dest.close();
            }
            if (fos != null) {
                fos.close();
            }
        }
        zipfile.close();
        is.close();
        if (dest != null) {
            dest.close();
        }
        if (fos != null) {
            fos.close();
        }
    }
    
    public static void unZip(final String zipFilePath, final String destinationFolder) throws IOException {
        unZip(zipFilePath, destinationFolder, "");
    }
    
    @Deprecated
    public static void copyFileAs(final File source, final String newName, final String destination) throws IOException {
        copyFileTo(source, String.valueOf(destination) + File.separator + newName);
    }
    
    public static String grepFileName(final String pathFileName) {
        final int size = pathFileName.length();
        int i;
        for (i = 0, i = size - 1; pathFileName.toCharArray()[i] != File.separatorChar && i >= 0; --i) {}
        return pathFileName.substring(i + 1, size);
    }
    
    public static boolean copySimpleFile(final File source, final File dest) throws IOException {
        FileChannel in = null;
        FileChannel out = null;
        try {
            in = new FileInputStream(source).getChannel();
            if (!dest.exists()) {
                safeMkdirs(dest.getParentFile());
                dest.createNewFile();
            }
            out = new FileOutputStream(dest).getChannel();
            in.transferTo(0L, in.size(), out);
        }
        catch (IOException e) {
            return false;
        }
        finally {
            if (out != null) {
                out.close();
            }
            if (in != null) {
                in.close();
            }
        }
        if (out != null) {
            out.close();
        }
        if (in != null) {
            in.close();
        }
        return true;
    }
    
    public static void deepCopy(final String input, final String output) throws IOException {
        if (input != null && output != null) {
            final File inputFile = new File(input);
            final File outputFile = new File(output);
            if (inputFile.exists() && !inputFile.getAbsolutePath().equals(outputFile.getAbsolutePath()) && isNotExcluded(input)) {
                if (inputFile.isDirectory()) {
                    final String[] fileNames = inputFile.list();
                    if (!outputFile.exists()) {
                        safeMkdirs(outputFile);
                    }
                    String[] array;
                    for (int length = (array = fileNames).length, i = 0; i < length; ++i) {
                        final String fileName = array[i];
                        deepCopy(String.valueOf(input) + "/" + fileName, String.valueOf(output) + "/" + fileName);
                    }
                }
                else {
                    copySimpleFile(inputFile, outputFile);
                }
            }
        }
    }
    
    private static boolean isNotExcluded(final String name) {
        final Pattern excludes = Pattern.compile(".git|.svn|.project");
        return !excludes.matcher(name).matches();
    }
    
    public static synchronized byte[] getBytesFromFile(final File file) throws IOException {
        final InputStream is = new FileInputStream(file);
        final long length = file.length();
        final byte[] bytes = new byte[(int)length];
        int offset = 0;
        for (int numRead = 0; offset < bytes.length && (numRead = is.read(bytes, offset, bytes.length - offset)) >= 0; offset += numRead) {}
        if (offset < bytes.length) {
            is.close();
            throw new IOException("Could not completely read file " + file.getName());
        }
        is.close();
        return bytes;
    }
    
    public static void moveNotUsedFilesTo(final String projectPath, final List<String> directories, final List<String> pathUsedFiles, final String tmpRoot) throws IOException {
        for (final String stringDirectory : directories) {
            final File currentDirectory = new File(String.valueOf(projectPath) + File.separator + stringDirectory);
            if (currentDirectory.isDirectory()) {
                File[] listFiles;
                for (int length = (listFiles = currentDirectory.listFiles()).length, i = 0; i < length; ++i) {
                    final File inputFile = listFiles[i];
                    if (!pathUsedFiles.contains(inputFile.getPath())) {
                        final File outputDir = new File(String.valueOf(tmpRoot) + File.separator + stringDirectory);
                        if (!outputDir.exists()) {
                            safeMkdirs(outputDir);
                            outputDir.deleteOnExit();
                        }
                        final File outputFile = new File(String.valueOf(outputDir.getPath()) + File.separator + inputFile.getName());
                        if (inputFile.exists()) {
                            if (inputFile.isDirectory()) {
                                copyDirectoryTo(inputFile.getAbsolutePath(), outputFile.getAbsolutePath(), new ArrayList<String>(), false, true);
                                deepDeleteDir(inputFile.getAbsolutePath());
                            }
                            else {
                                copySimpleFile(inputFile, outputFile);
                                inputFile.delete();
                            }
                        }
                    }
                }
            }
        }
    }
    
    public static void deleteNotUsedFiles(final String projectPath, final List<String> directories, final List<String> pathUsedFiles) throws IOException {
        for (final String stringDirectory : directories) {
            final File currentDirectory = new File(String.valueOf(projectPath) + File.separator + stringDirectory);
            if (currentDirectory.isDirectory()) {
                File[] listFiles;
                for (int length = (listFiles = currentDirectory.listFiles()).length, i = 0; i < length; ++i) {
                    final File inputFile = listFiles[i];
                    if (!pathUsedFiles.contains(inputFile.getPath()) && inputFile.exists()) {
                        if (inputFile.isDirectory()) {
                            deepDeleteDir(inputFile.getAbsolutePath());
                        }
                        else {
                            inputFile.delete();
                        }
                    }
                }
            }
        }
    }
    
    public static boolean validateFilename(final String fileName) {
        return fileName.matches(".*[\\\\|/|\\||:|\\?|\\*|\"|<|>].*");
    }
    
    public static String correctSeparators(final String path) {
        String correctedPath = path;
        final boolean isFileURL = correctedPath.startsWith("file:///") || correctedPath.startsWith("\\");
        if (!isFileURL) {
            correctedPath = replaceFileSeparator(correctedPath);
        }
        return addPathSeparatorIfNecessary(correctedPath);
    }
    
    public static final String getTempDir() {
        if (FileUtils.tempDir == null) {
            String tempPath = System.getProperty("java.io.tmpdir");
            if (!tempPath.endsWith(File.separator)) {
                tempPath = String.valueOf(tempPath) + File.separator;
            }
            tempPath = String.valueOf(tempPath) + "Justinmind" + File.separator + UUID.randomUUID() + File.separator;
            final File tempDirFile = new File(tempPath);
            if (!tempDirFile.exists()) {
                tempDirFile.mkdirs();
            }
            FileUtils.tempDir = tempPath;
        }
        return FileUtils.tempDir;
    }
    
    public static String replaceFileSeparator(final String path) {
        String correctedPath;
        for (correctedPath = path, correctedPath = correctedPath.replaceAll("\\\\", "/"); correctedPath.contains("//"); correctedPath = correctedPath.replaceAll("//", "/")) {}
        return correctedPath;
    }
    
    public static String addPathSeparatorIfNecessary(final String path) {
        final StringBuilder pathWithSeparator = new StringBuilder("");
        if (path != null && !path.equals("")) {
            pathWithSeparator.append(path);
            if (!path.endsWith(File.pathSeparator) && !path.endsWith("\\") && !path.endsWith(".jsp")) {
                pathWithSeparator.append(File.pathSeparator);
            }
        }
        return pathWithSeparator.toString();
    }
    
    public static byte[] readFileBytes(final String path) throws IOException {
        final File file = new File(path);
        final byte[] b = new byte[(int)file.length()];
        final FileInputStream fileInputStream = new FileInputStream(file);
        fileInputStream.read(b);
        return b;
    }
    
    public static String readFile(final String path) throws IOException {
        String result = null;
        DataInputStream in = null;
        try {
            final File f = new File(path);
            final byte[] buffer = new byte[(int)f.length()];
            in = new DataInputStream(new FileInputStream(f));
            in.readFully(buffer);
            result = new String(buffer);
        }
        catch (IOException e) {
            throw new RuntimeException("IO problem in readFile", e);
        }
        finally {
            try {
                in.close();
            }
            catch (IOException ex) {}
        }
        try {
            in.close();
        }
        catch (IOException ex2) {}
        return result;
    }
    
    public static File searchFileByName(final File file, final String name) {
        if (file.getName().equals(name)) {
            return file;
        }
        if (file.isDirectory()) {
            File[] listFiles;
            for (int length = (listFiles = file.listFiles()).length, i = 0; i < length; ++i) {
                final File child = listFiles[i];
                final File result = searchFileByName(child, name);
                if (result != null) {
                    return result;
                }
            }
        }
        return null;
    }
    
    public static List<String> fileToLines(final String filename) throws IOException {
        final List<String> lines = new LinkedList<String>();
        String line = "";
        final BufferedReader in = new BufferedReader(new FileReader(filename));
        while ((line = in.readLine()) != null) {
            lines.add(line);
        }
        in.close();
        return lines;
    }
}
